package com.gangstar;

import java.util.ArrayList;

/**
 * BlueFamily promises to implement Family, which is
 * infact a Observable of the observer pattern
 * @author Japskua
 * @version 1.0
 *
 */
public class BlueFamily implements Family {

	private ArrayList<Gangster>members = new ArrayList<Gangster>();
	private String state;
	
	public BlueFamily() {
		members.clear();
	}
	
	@Override
	public void JoinFamily(Gangster gangster) {
		members.add(gangster);
	}
	
	public void LeaveFamily(Gangster gangster) {
		members.remove(gangster);
	}
	
	public String getState() {
		return state;
	}
	
	public void setState(String state) {
		this.state = state;
		StateChanged();
	}
	
	/**
	 * This function is used to announce all the Family members 
	 * that the current state has changed and asks them to ask for 
	 * more information
	 * @author Japskua
	 * 
	 */
	private void StateChanged() {
		for (Gangster item: members) {
			item.update(getState());
		}
	}

}
