package com.gangstar;

import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLUtils;

public class Bullet {

	private float shooterPosX;
	private float shooterPosY;
	private float targetPosX;
	private float targetPosY;
	private float posX;
	private float posY;
	private int steps = 15;
	private int temp_var;
	float distanceX;
	float distanceY;
	
	/** The buffer holding the vertices */
	private FloatBuffer vertexBuffer;
	/** The buffer holding the texture coordinates */
	private FloatBuffer textureBuffer;
	/** The buffer holding the indices */
	private ByteBuffer indexBuffer;
	
	/** Our texture pointer */
	private int[] textures = new int[1];
	
	private float vertices[] = { 
//            -0.3f, -0.3f, -0.3f,	//lower back left (0)
//            0.3f, -0.3f, -0.3f,		//lower back right (1)
//            0.3f,  0.3f, -0.3f,		//upper back right (2)
//            -0.3f, 0.3f, -0.3f,		//upper back left (3)
//            -0.3f, -0.3f,  0.3f,	//lower front left (4)
//            0.3f, -0.3f,  0.3f,		//lower front right (5)
//            0.3f,  0.3f,  0.3f,		//upper front right (6)
//            -0.3f,  0.3f,  0.3f		//upper front left (7)
//			-0.3f, -0.3f, 0.0f, //Vertex 0
//    		0.3f, -0.3f, 0.0f,  //v1
//    		-0.3f, 0.3f, 0.0f,  //v2
//    		0.3f, 0.3f, 0.0f,   //v3
//    		
//    		0.3f, -0.3f, 0.0f,	//...
//    		0.3f, -0.3f, 0.0f,
			-1.0f, -1.0f, 0.0f, //Vertex 0
    		1.0f, -1.0f, 0.0f,  //v1
    		-1.0f, 1.0f, 0.0f,  //v2
    		1.0f, 1.0f, 0.0f,   //v3
    		
    		1.0f, -1.0f, 0.0f,	//...
    		1.0f, -1.0f, 0.0f,
											};
	
	private float texture[] = {    		
    		//Mapping coordinates for the vertices
    		0.0f, 0.0f,
    		0.0f, 1.0f,
    		1.0f, 0.0f,
    		1.0f, 1.0f, 
    		
    		0.0f, 0.0f,
    		0.0f, 1.0f, };
   
	/** The initial color definition */	

	private byte indices[] = {
			/*
			 * Example: 
			 * Face made of the vertices lower back left (lbl),
			 * lfl, lfr, lbl, lfr, lbr
			 */
//            0, 4, 5,    0, 5, 1,
//            //and so on...
//            1, 5, 6,    1, 6, 2,
//            2, 6, 7,    2, 7, 3,
//            3, 7, 4,    3, 4, 0,
//            4, 7, 6,    4, 6, 5,
//            3, 0, 1,    3, 1, 2
    		0,1,3, 0,3,2, 			//Face front
								};

	public void SetShooterX(float shooterX)
	{
		shooterPosX = shooterX;
		posX = shooterPosX;
		temp_var = 0;
	}
	public void SetShooterY(float shooterY)
	{
		shooterPosY = shooterY;
		posY = shooterPosY;
	}
	public void SetTargetX(float targetX)
	{
		targetPosX = targetX;
	}
	public void SetTargetY(float targetY)
	{
		targetPosY = targetY;
	}
	
//	public Bullet(float shooterX, float shooterY, float targetX, float targetY) {
	public Bullet() {
		

		//
		ByteBuffer byteBuf = ByteBuffer.allocateDirect(vertices.length * 4);
		byteBuf.order(ByteOrder.nativeOrder());
		vertexBuffer = byteBuf.asFloatBuffer();
		vertexBuffer.put(vertices);
		vertexBuffer.position(0);

		//
		byteBuf = ByteBuffer.allocateDirect(texture.length * 4);
		byteBuf.order(ByteOrder.nativeOrder());
		textureBuffer = byteBuf.asFloatBuffer();
		textureBuffer.put(texture);
		textureBuffer.position(0);

		//
		indexBuffer = ByteBuffer.allocateDirect(indices.length);
		indexBuffer.put(indices);
		indexBuffer.position(0);
		
		
	}
	
	
	
	
	public float CalculatePosX() {
		
		distanceX = shooterPosX - targetPosX;
		posX = posX - distanceX/steps;
		
		return posX;
	}
	
	public float CalculatePosY() {
		
		distanceY = shooterPosY - targetPosY;
		posY = posY - distanceY/steps;
		
		return posY;
	}
	
	public boolean draw(GL10 gl) {
		
		if (temp_var < steps)
		{
			//gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);
			gl.glPushMatrix();gl.glBindTexture(GL10.GL_TEXTURE_2D, textures[0]);
			
			//Point to our buffers
			gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
			gl.glEnableClientState(GL10.GL_TEXTURE_COORD_ARRAY);

			//Set the face rotation
			gl.glFrontFace(GL10.GL_CCW);
			
			//Enable the vertex and texture state
			gl.glVertexPointer(3, GL10.GL_FLOAT, 0, vertexBuffer);
			gl.glTexCoordPointer(2, GL10.GL_FLOAT, 0, textureBuffer);
			
			
			gl.glTranslatef(CalculatePosX(), CalculatePosY(), 0);
			
			
			gl.glRotatef( (posX*posY)*5 , 0, 0, 1);
			gl.glScalef(0.62f, 1.0f, 1);
			
			
			
			//gl.glColor4f(1, 1, 0, 1);
			gl.glDrawElements(GL10.GL_TRIANGLES, indices.length, GL10.GL_UNSIGNED_BYTE, indexBuffer);
			//gl.glDrawElements(GL10.GL_TRIANGLES, 36, GL10.GL_UNSIGNED_BYTE, indexBuffer);
			
			gl.glDisableClientState(GL10.GL_VERTEX_ARRAY);
			gl.glDisableClientState(GL10.GL_TEXTURE_COORD_ARRAY);
			gl.glPopMatrix();
			temp_var++;
			return true;
		}
		else
			return false;
		
	}
	
	public void loadGLTexture(GL10 gl, Context context) {
		//Get the texture from the Android resource directory
		InputStream is = context.getResources().openRawResource(R.drawable.bullet);
		Bitmap bitmap = null;
		try {
			//BitmapFactory is an Android graphics utility for images
			bitmap = BitmapFactory.decodeStream(is);

		} finally {
			//Always clear and close
			try {
				is.close();
				is = null;
			} catch (IOException e) {
			}
		}

		//Generate one texture pointer...
		gl.glGenTextures(1, textures, 0);
		//...and bind it to our array
		gl.glBindTexture(GL10.GL_TEXTURE_2D, textures[0]);
		
		//Create Nearest Filtered Texture
		gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, GL10.GL_NEAREST);
		gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MAG_FILTER, GL10.GL_LINEAR);

		//Different possible texture parameters, e.g. GL10.GL_CLAMP_TO_EDGE
		gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_WRAP_S, GL10.GL_REPEAT);
		gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_WRAP_T, GL10.GL_REPEAT);
		
		//Use the Android GLUtils to specify a two-dimensional texture image from our bitmap
		GLUtils.texImage2D(GL10.GL_TEXTURE_2D, 0, bitmap, 0);
		
		//Clean up
		bitmap.recycle();
	}
}
